# RSNe.py.     I. Marti-Vidal.      IMPRS Blackboard Lectures 2011.
# SILLY SCRIPT FOR A SILLY CHECKING OF THE SMART BAYES RELATION.

import numpy

PIa = 0.3 # Fraction of type Ia SNe (no matter radioemission).
PIb = 0.2 # Fraction of type Ib SNe (no matter radioemission).
PII = 0.5 # Fraction of type II SNe (no matter radioemission). 

PR = 0.3   # Probability of any SN to be radio loud.
PIIR = 0.75 # Fraction of radio-loud SNe of type II.
PIbR = 0.25 # Fraction of radio-loud SNe of type Ib.

nSNe = 1000 # Number of SNe to simulate.

# Create vector of all SNe (column 0 is SN type; column 1 is radioemission):
# Types: 0 -> Ia ;   1 -> Ib ;   2 -> II.

SNIa = int(PIa*nSNe)*[[0,False]] 
SNIb = int(PIbR*PR*nSNe)*[[1,True]] + int((PIb-PIbR*PR)*nSNe)*[[1,False]]
SNII = int(PIIR*PR*nSNe)*[[2,True]] + int((PII-PII*PR)*nSNe)*[[2,False]]

SNTot = numpy.array(SNIa + SNIb + SNII)

# QUESTION 1:
# Supernova of type I. Probability to be radio-loud?

cond1 = numpy.logical_or( SNTot[:,0]==0, SNTot[:,0]==1 )
SNTypeI = SNTot[cond1]                     # Select all SNe which are of type I.
SNTypeIR = SNTypeI[SNTypeI[:,1]==True]     # Select only those radio loud.


# QUESTION 2:
# Supernova of type Ib. Probability to be radio-loud?

SNTypeIb = SNTot[SNTot[:,0]==1]            # Select all SNe of type I.
SNTypeIbR = SNTypeIb[SNTypeIb[:,1]==True]  # Select only those radio loud.

# QUESTION 3:
# Supernova radio-quiet. Probability to be of type Ia?

SNnotR = SNTot[SNTot[:,1]==False]          # Select all radio-quiet SNe.
SNnotRIa = SNnotR[SNnotR[:,0]==0]          # Select only those of type Ia.


# PRINT ANSWERS:

print " QUESTION 1: ", float(len(SNTypeIR))/len(SNTypeI)
print " QUESTION 2: ", float(len(SNTypeIbR))/len(SNTypeIb)
print " QUESTION 3: ", float(len(SNnotRIa))/len(SNnotR)

